/// <reference types="node" />
import 'reflect-metadata';
import { ApolloServer, Config as ApolloServerConfig } from 'apollo-server-micro';
import { ServerRegistration } from 'apollo-server-micro/dist/ApolloServer';
import { MicroRequest } from 'apollo-server-micro/dist/types';
import { BuildSchemaOptions } from 'type-graphql/dist/utils/buildSchema';
import { ConnectionOptions } from 'typeorm';
import { ServerResponse } from 'http';
export interface TypeGraphQLOptions {
    schema: BuildSchemaOptions;
}
export interface TypeormConnectionOptions {
    typeormOptions?: Record<string, ConnectionOptions>;
}
export declare type Config = Omit<ApolloServerConfig, 'schema' | 'typeDefs' | 'resolvers'> & ServerRegistration & TypeGraphQLOptions & TypeormConnectionOptions;
export declare class TypeGraphQLServer extends ApolloServer {
    readonly typeormOptions: TypeormConnectionOptions['typeormOptions'];
    readonly buildSchema: BuildSchemaOptions;
    readonly serverRegistration: ServerRegistration;
    constructor({ schema, typeormOptions, path, disableHealthCheck, onHealthCheck, ...rest }: Config);
    createHandler(): (req: MicroRequest, res: ServerResponse) => Promise<void>;
}
