"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeGraphQLServer = void 0;
require("reflect-metadata");
const apollo_server_micro_1 = require("apollo-server-micro");
const buildSchema_1 = require("type-graphql/dist/utils/buildSchema");
const typeorm_1 = require("./adapters/typeorm");
class TypeGraphQLServer extends apollo_server_micro_1.ApolloServer {
    constructor({ schema, typeormOptions, path, disableHealthCheck, onHealthCheck, ...rest }) {
        super({ ...rest, schema: buildSchema_1.buildSchemaSync(schema) });
        this.typeormOptions = typeormOptions;
        this.buildSchema = schema;
        this.serverRegistration = { path, disableHealthCheck, onHealthCheck };
    }
    createHandler() {
        if (this.typeormOptions) {
            return async (req, res) => {
                await typeorm_1.connectTypeorm('default', this.typeormOptions);
                return super.createHandler(this.serverRegistration)(req, res);
            };
        }
        return super.createHandler(this.serverRegistration);
    }
}
exports.TypeGraphQLServer = TypeGraphQLServer;
